// TestRun.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


int _tmain(int argc, _TCHAR* argv[])
{
	wchar_t szModulePath[MAX_PATH+1] = {0};

	if (::GetModuleFileName(NULL, szModulePath, _countof(szModulePath)-1) == 0)
	{
		::MessageBox(NULL, L"Failed to get exe path.", L"TestRun", MB_OK);
		return -1;
	}

	std::wstring strExePath = szModulePath;
	LeoHelpers::GetParentPathString(&strExePath, false);

	std::wstring strCurPath = strExePath;

	strExePath += L"\\EXE\\TestLink.exe";
	strCurPath += L"\\DLL";

	HANDLE hProc = NULL;



	// This shouldn't fail, unless the EXE and DLL dirs aren't there at all.
	// The called process shouldn't fail either (unless CWDIllegalInDllSearch = 0xFFFFFFFF in the registry, of course).
	if (!LeoHelpers::CreateProcessWrapper(strExePath.c_str(), NULL, false, strCurPath.c_str(), false, &hProc))
	{
		::MessageBox(NULL, L"First launch failed.", L"TestRun", MB_OK);
	}
	else
	{
		::WaitForSingleObject(hProc, INFINITE);
		hProc = NULL;
	}



	// Make the DLL search-path secure for our process.
	// Here is the problem:
	//    Changing *our* DLL path to remove the current-directory
	//        will break running a child process that depends on it!
	::SetDllDirectory(L"");

	// This shouldn't fail, unless the EXE and DLL dirs aren't there at all.
	// The called process should fail to run properly, however.
	if (!LeoHelpers::CreateProcessWrapper(strExePath.c_str(), NULL, false, strCurPath.c_str(), false, &hProc))
	{
		::MessageBox(NULL, L"Second launch failed.", L"TestRun", MB_OK);
	}
	else
	{
		::WaitForSingleObject(hProc, INFINITE);
		hProc = NULL;
	}



	// Reset the DLL search path to the default.
	::SetDllDirectory(NULL);

	// This shouldn't fail, unless the EXE and DLL dirs aren't there at all.
	// The called process should work again.
	if (!LeoHelpers::CreateProcessWrapper(strExePath.c_str(), NULL, false, strCurPath.c_str(), false, &hProc))
	{
		::MessageBox(NULL, L"Third launch failed.", L"TestRun", MB_OK);
	}
	else
	{
		::WaitForSingleObject(hProc, INFINITE);
		hProc = NULL;
	}



	return 0;
}

